#include "ManyRunsLogicInfo.hpp"

ManyRunsLogicInfo::ManyRunsLogicInfo()
    :
        isManualOrder( std::vector< bool >( MAX_MOB_TYPES , false ) ),
        manualOrder( std::vector< std::vector<int> >( MAX_MOB_TYPES , std::vector<int>() ) )
{
    for( int i = 0 ; i < MAX_FIELD_SIZE ; i++ )
        std::fill( maxWasteDamage[i] , maxWasteDamage[i] + MAX_FIELD_SIZE , 1.0 );
}

bool ManyRunsLogicInfo::setManualOrdering( int id , std::vector< int > order ){
    static int got[MAX_TURRET_COUNT];
    
    if( order.size() != MAX_TURRET_COUNT )
        return false;
    
    std::fill( got , got + MAX_TURRET_COUNT , 0 );
    
    for( int i = 0 ; i < MAX_TURRET_COUNT ; i++ ){
        if( got[ order[i] ] )
            return false;
        
        got[ order[i] ]++;
    }
    
    /// Should be OK by now
    
    isManualOrder[id] = true;
    manualOrder[id] = order;
    
    return true;
}
