#ifndef QUADTREE_HPP_INCLUDED
#define QUADTREE_HPP_INCLUDED

#include "main.hpp"

struct Quadtree{
    /**
     * The size of the tree
     * Note: allows for square fields only
     * Use max(rows,cols)
     */
    int size;
    
    std::vector< double > data;
    std::vector< double > self;
    
    Quadtree( int size , double init );
    
    double query( int upper_left_x , int upper_left_y , int lower_right_x , int lower_right_y ) const;
    void update( int upper_left_x , int upper_left_y , int lower_right_x , int lower_right_y , double value );
    
    protected:
    
    void _update( int at , 
        int upper_left_x , int upper_left_y , int lower_rigth_x , int lower_right_y ,
        int my_upper_left_x , int my_upper_left_y , int my_lower_right_x , int my_lower_right_y ,
        double value );
    double _query( int at , 
        int upper_left_x , int upper_left_y , int lower_rigth_x , int lower_right_y ,
        int my_upper_left_x , int my_upper_left_y , int my_lower_right_x , int my_lower_right_y
        ) const;
    void _build( int at , int upper_left_x , int upper_left_y , int lower_right_x , int lower_right_y , double value );
};

#endif // QUADTREE_HPP_INCLUDED
