#ifndef SEGMENTTREE_HPP_INCLUDED
#define SEGMENTTREE_HPP_INCLUDED

#include "main.hpp"

typedef int64 (*aggregate_fn_type)( int64 , int64 );

struct Segmenttree{
    /**
     * The size of the segment tree
     */
    int size;
    
    aggregate_fn_type aggregate;
    aggregate_fn_type updatefn;
    
    std::vector<int64> data;
    
    Segmenttree( int size , aggregate_fn_type aggregate , aggregate_fn_type updatefn , int64 init = 0ull );
    
    int64 query( int l , int r ) const;
    void update( int x , int64 value );
    
    protected:
    
    int64 _query( int at , int l , int r , int a , int b ) const;
    void _update( int at , int l , int r , int x , int64 value );
};

#endif // SEGMENTTREE_HPP_INCLUDED
