#include "TextGame.hpp"

/**
 * To do: remove the random numbers,
 *  replace w/ constants
 */
 
TextGame::TextGame( int rows , int cols , const char field[MAX_FIELD_SIZE][MAX_FIELD_SIZE] )
    :
        Game( rows , cols , field )
{
    
}

int TextGame::buyTurret( int turret_id , int x , int y , const std::vector< FieldCellCoord > upgrades ){
    if( !field->isInside( x , y ) )
        return -3;
    
    int needed = static_cast<int>( upgrade_graph[turret_id].size() );
    
    int provided = static_cast<int>( upgrades.size() );
    
    if( needed != provided )
        return -5;
    
    for( int i = 0 ; i < provided ; i++ ){
        /**
         * The coordinates of (one of) the turret(s) being upgraded
         */
        int upgrade_x = upgrades[i].x;
        int upgrade_y = upgrades[i].y;
        
        if( !field->isTurret( upgrade_x , upgrade_y ) )
            return -6;
        
        int placed_turret_id = static_cast<int>( field->getTurretId( upgrade_x , upgrade_y ) );
        
        if( getTurret( placed_turret_id )->type != all_turrets[ upgrade_graph[turret_id][i] ] )
            return -7;
    }
    
    /// Remove the upgrades, but make sure the turret will be bought
    if( _turrets_built == MAX_TURRET_COUNT)
        return -1;
    if( money < all_turrets[turret_id]->buy_price )
        return -2;
    
    bool isFree = field->isFree( x , y );
    
    for( int i = 0 ; i < provided ; i++ ){
        /**
         * Won't actually get any money from this
         */
        int upgrade_x = upgrades[i].x;
        int upgrade_y = upgrades[i].y;
        
        if( Game::sellTurret( upgrade_x , upgrade_y , true ) != true ){
            assert( 0 );
        }
        
        if( upgrade_x == x and upgrade_y == y )
            isFree = true;
    }
    
    if( !isFree )
        return -3;
    
    /// should always return true!
    int buy_result = Game::buyTurret( all_turrets[turret_id] , x , y );
    
    assert( buy_result >= 0 );
    
    return buy_result;
}
