#ifndef TEXTGAME_HPP_INCLUDED
#define TEXTGAME_HPP_INCLUDED

#include "main.hpp"
#include "Game.hpp"

struct Turret;

struct TextGame : virtual public Game{
    /**
     * Adds:
     *  - read() from a text file all the info and setup the game
     *  - upgrades for turrets
     */
    
    /**
     * The place where all the turrets are stored
     */
    std::vector< Turret* > all_turrets;
    /**
     * The place where all the mobs are stored
     */
    std::vector< Mob* > all_mobs;
    /**
     * The waves represented in (mob,count) vectors
     *  and the money on completion
     */
    std::vector< std::vector< std::pair<int,int> > > all_waves;
    std::vector< int64 > money_on_completion;
    
    /**
     * The upgrade DAG
     */
    std::vector< std::vector< int > > upgrade_graph;
    
    TextGame( int rows , int cols , const char field[MAX_FIELD_SIZE][MAX_FIELD_SIZE] );
    
    virtual int buyTurret( int turret_id , int x , int y , const std::vector< FieldCellCoord > upgrades );
};

#endif // TEXTGAME_HPP_INCLUDED
