#ifndef TURRET_HPP_INCLUDED
#define TURRET_HPP_INCLUDED

#include "main.hpp"

const int TURRET_MOD_RATE = 0;
const int TURRET_MOD_DAMAGE = 1;
const int TURRET_BATTLE = 2;

struct Turret{
    /**
     * The rate of the tower in
     *  times / second
     */
    int rate;
    /**
     * The damage of the tower
     *  for each of the mob types
     * OR 
     *  if a damage/rate modifier turret
     *   the coefficient by which it changes
     *   each damage/rate type
     */
    double affect[MAX_MOB_TYPES];
    /**
     * The prices of the tower
     *  buy_price - how much to buy
     *  sell_price - how much you get if you sell
     */
    int buy_price;
    int sell_price;
    /**
     * The range of the tower
     *  Note: this is not a radius
     *   but rather describes a rectangle
     */
    int range;
    /**
     * The name of the tower
     */
    std::string name;
    /**
     * The type of the turret
     */
    int type;

    Turret();
};

#endif // TURRET_HPP_INCLUDED
