#ifndef WAVEINFO_HPP_INCLUDED
#define WAVEINFO_HPP_INCLUDED

#include "main.hpp"

/**
 * Will hold some statistics about
 *  each wave run
 */
struct WaveInfo{
    /**
     * field->wave basically
     */
    int wave_id;
    /**
     * length in seconds
     */
    int length;
    /**
     * Which call is this to that function in that second
     */
    int call_id;
    /**
     * Mobs total count
     */
    int mobs_total;
    /**
     * Mobs killed, mobs_alive = mobs_total - mobs_killed
     */
    int mobs_killed;
    /**
     * Total damage done
     */
    double total_damage_done;
    /**
     * Waste damage (if a turret doing 50 damage/hit hits a
     *  1 mob with 1HP then 49 damage is wasted)
     */
    double total_waste_damage;
};

#endif // WAVEINFO_HPP_INCLUDED
