#ifndef WAVERUNNER_HPP_INCLUDED
#define WAVERUNNER_HPP_INCLUDED

#include "main.hpp"
#include "WaveInfo.hpp"
#include "RunningMob.hpp"
#include "PlacedTurret.hpp"
#include "Game.hpp"
#include "ManyRunsLogicInfo.hpp"

void waveRunLogicOneInRangeCall( WaveRunner *waveRunner , const std::vector< RunningMob* > &mobs , Game &game , WaveInfo *result , void *argument = NULL );
void waveRunLogicManyInRangeCalls( WaveRunner *waveRunner , const std::vector< RunningMob* > &mobs , Game &game , WaveInfo *result , void *argument = NULL );

/**
 * Holds the wave logic, used by Game
 */
struct WaveRunner{
    /**
     * Some callbacks, set them up before using run()
     */
    WaveRunner_Callback_Type mobInRange;
    WaveRunner_Callback_Type mobFellDead;
    WaveRunner_Callback_Type mobReachedTheEnd;
    
    WaveRunner_Logic_Callback waveRunLogic;
    
    /**
     * 
     */
    
    /**
     * The main function
     *  Free all the memory taken by RunningMob* after the wave
     */
    WaveInfo *run( const std::vector< RunningMob* > &mobs , Game &game , void *argument = NULL );
};

#endif // WAVERUNNER_HPP_INCLUDED
