#pragma once
#ifndef TEST_HPP_01C3156F44B80F
#define TEST_HPP_01C3156F44B80F

#include "TextGame.hpp"
#include "Game.hpp"
#include "ManyRunsLogicInfo.hpp"

#define NEGATIVE_RATE_MAGIC 10.0
#define TYPE_PERCENT_MAGIC 0.6 // @0.7 = 81%
#define MOB_COUNT_MAGIC 3.5
#define MOB_SCORE_MAGIC 1.0 // was 1.39f
#define MOB_HP_MAGIC 0.7
#define MOB_SPEED_MAGIC 18

enum is_result_e {
	IS_REJECT = 0,
	IS_ACCEPT = 1,
	IS_DONE = 2, /* !? */
};

enum is_execute_e {
	IS_MODE_RUN,
	IS_MODE_REVERT,
};

enum upgrade_mode_e {
	UP_MANUAL=0,
	UP_AUTO,
};

//typedef std::deque<int> instruction_set;

/*----------------------------------------------*/ 

void ts_print_map(TextGame *game );
void ts_print_turrets_info(const Game *game);
int ts_cell_test_coverage(const Game *game, int x, int y, int range);
void ts_cache_cell_coverage(const Game *game);
void ts_cached_coverage_remove_spot(int x, int y);
void ts_calc_tower_type_score(TextGame *game, int wave);
int ts_get_bestturret_type(const TextGame *game, int mob_type, int64 max_price, int max_upgrades);
FieldCellCoord ts_buy_turret(TextGame *game, ManyRunsLogicInfo *loficinfo , int turret_id, std::vector< FieldCellCoord > upgrades); // buy turret, 1 = OK
void bye(TextGame *game, int wave, int total_upgrades);
void ts_set_type_order(TextGame *game, int type, ManyRunsLogicInfo *logicInfo);
void ts_cache_single_tower_score(TextGame *game);
void ts_cache_mob_hp(TextGame *game);
int ts_init_coverage_test(TextGame *game);
void ts_print_turret_report(TextGame *game);
std::deque<std::string> buildstring_to_deque(std::string bs);

/*----------------------------------------------*/ 

struct coverage  {
	int x, y, cov;
	coverage(int x, int y, int cov);
	// ne rabotiat za sort??
	bool operator<( const coverage &a ) const;
	bool operator() (const coverage &a, const coverage &b ) const;

};

/*----------------------------------------------*/ 

extern std::deque<coverage *> cached_coverage[64];
extern double ts_tower_score[16]; // sum of damage
extern double ts_tower_score_wave[16];
extern double ts_tower_score_total[16];
extern double ts_tower_score_single[64][16]; // solo score
extern int mob_type_reorder[16];

// wave_type score
extern double wave_type_score[3000][16];
extern unsigned int wave_mob_types[3000];
extern unsigned char ts_map_turrets[64][64]; // store turret ids (to draw map)
extern uint64_t total_tower_cost[64]; // total. tower price + ugprades
extern uint32_t tower_cost_towers[64]; //tower price in towers
extern unsigned int mob_hp[16]; // for every mob type

extern std::vector< RunningMob* > all_mobs[3000];
extern std::deque< std::pair<int, double> > ts_sorted_tower_score;

#endif /* TEST_HPP_01C3156F44B80F */

